/**
 * 工单分配
 * */

$(document).ready(function() {
	autosize($('textarea'));
	var ID = helper.request.queryString("oid"); //工单编号
	if(ID) {
		getWorkOrderInfo(ID);
	}

	//tree下拉框效果
	$(".inpBox .tree").click(function() {
		if($(this).parent().find(".addTree").is(":hidden")) {
			$(this).parent().find(".addTree").show();
		} else {
			$(this).parent().find(".addTree").hide();
		}
	});
	
	//普通下拉框效果
	$(".inpBox .select").click(function() {
		if($(this).parent().find(".xl_common").is(":hidden")) {
			$(this).parent().find(".xl_common").show();
		} else {
			$(this).parent().find(".xl_common").hide();
		}
	});
	
	$(".xl").click(function() {
		if($(this).parent().find(".addTree").is(":hidden")) {
			$(this).parent().find(".addTree").show();
		} else {
			$(this).parent().find(".addTree").hide();
		}
		if($(this).parent().find(".xl_common").is(":hidden")) {
			$(this).parent().find(".xl_common").show();
		} else {
			$(this).parent().find(".xl_common").hide();
		}
	});
	
	$(".inpBox").mouseleave(function() {
		$(this).children(".addTree").hide();
		$(this).children(".xl_common").hide();
	});
	
	$(".xl_box").on("click", "li", function() {
		var obj = $(this).parent().parent().parent();
		obj.find("input").eq(0).val($(this).text());
		obj.find("input").eq(1).val($(this).attr("itemid"));
		obj.find(".xl_common").hide();
	});
	
	getBM($("#zrbmtree"));
	
	//点击确定
	$("#clgd").click(function() {
		if(!$("#clbm").val()) {
			layer.confirm('请选择接收部门！', {
				icon: 2,
				btn: ['确定']
			});
			return;
		}
//		if(!$("#cont").val()) {
//			layer.confirm('请输入处理内容！', {
//				icon: 2,
//				btn: ['确定']
//			});
//			return;
//		}
		dealWorkOrder(ID);
	});

})

//获取工单信息
function getWorkOrderInfo(oid) {
	$.ajax({
		type: "get",
		url: huayi.config.callcenter_url + "WorkOrder/GetWorkOrder",
		async: true,
		dataType: 'json',
		data: {
			orderid: oid,
			token: $.cookie("token")
		},
		success: function(data) {
			/*验证请求*/
			if(data.state == "success") {
				var Str = data.data.data;
				if(Str && Str.length > 0) {
					$('#cl_gdbh').text(Str[0].WorkOrderID); //工单编号
					$("#cl_gdlx").text(Str[0].GDLXName); //工单类型
					$("#xq_source").text(Str[0].GDLYName); //工单来源
					$("#xq_handle").text(Str[0].YWLXName); //业务办理
					$("#cl_khxm").text(Str[0].Customer); //姓名
					$("#cl_khdh").text(helper.filter.cutTel(Str[0].CustomerTel)); //电话
					$('#cl_gdnr').text(decodeURIComponent(Str[0].Detail));

					//微信内文件（暂时不用）
					var Files = Str[0].Files;
					if(Files) {
						var a;
						var b;
						$(Files).each(function(i, n) {
							a = n.F_FileType.split("\/")[0];
							b = n.F_FileName.split(".")[1];
//							console.log(a);
							if(a == 'image') {
								$('<div class="img-box"><a href="+' + n.F_FileUrl + '" download="' + n.F_FileName + '"><img src="' + n.F_FileUrl + '" alt="" class="image-item"  data-preview-group="1" /><span class="">' + b + '</span></a><div>').appendTo(".space");
							} else {
								$('<div class="img-box "><a href="+' + n.F_FileUrl + '" download="' + n.F_FileName + '"><span class="">' + b + '</span></a><div>').appendTo(".space");
							}

						})
					}

				}
			}
		}
	});
}

//获取工单类型
function getTypeName(val) {
	var str = '';
	switch(val + '') {
		case '107':
			str = "咨询";
			break;
		case '108':
			str = "投诉";
			break;
	}
	return str;
}

//获取部门
var setting = {
	data: {
		key: {
			name: "text"
		},
		simpleData: {
			enable: true,
			idKey: "id",
			pIdKey: "ParentId",
			rootPId: 0
		}
	},
	callback: {
		onClick: zTreeOnClick
	}
};

function getBM(obj) {
	$.getJSON(huayi.config.callcenter_url + 'Department/GetDeptList', {
		token: $.cookie("token")
	}, function(result) {
		if(result.state.toLowerCase() == "success") {
			var treeObj = $.fn.zTree.init(obj, setting, result.data);
			treeObj.expandAll(true);
		}
	})
}

function zTreeOnClick(event, treeId, treeNode) {
	if(event) {
		event.stopPropagation();
	}
	var obj = $("#" + event.data.treeId).parent();
	obj.parent().find("input").eq(0).val(treeNode.text);
	obj.parent().find("input").eq(1).val(treeNode.id);
	obj.hide();
	getRY($(".clid"), $("#clbm").val());
};

//获取人员
function getRY(obj, deptid) {
	var proid = helper.request.queryString("proid"); //项目id
	obj.empty();
	obj.append('<li itemid="">--请选择--</li>');
	obj.parent().parent().find("input").eq(0).val("--请选择--");
	obj.parent().parent().find("input").eq(1).val("");
	$.getJSON(huayi.config.callcenter_url + 'UserAccount/GetDeptUserList', {
		proid: proid,
		deptid: deptid,
		token: $.cookie("token")
	}, function(result) {
		if(result.state.toLowerCase() == "success") {
			$(result.data).each(function(i, n) {
				obj.append('<li itemid="' + n.F_UserId + '">' + n.F_UserName + '(' + n.F_UserCode + ')</li>');
			});
			obj.find("li").click(function(event) {
				if(event) {
					event.stopPropagation();
				}
				$(this).parent().parent().parent().find("input").eq(0).val($(this).text());
				$(this).parent().parent().parent().find("input").eq(1).val($(this).attr("itemid"));
				$(this).parent().parent().hide();
			});
		}
	})
}

//派单（分配）
function dealWorkOrder(oid) {
	// var ltype = $("input[name='ltype']:checked").val();
	var isDetail = helper.request.queryString("isDetail"); //是否是详情页面的处理
	
	// if($.trim($('#clbmname').val()) && !$('#clid').val()){
	// 	layer.confirm('请选择接收人！', {
	// 		icon: 2,
	// 		btn: ['确定']
	// 	});
	// 	return;
	// }
	
	$.post(huayi.config.callcenter_url + 'WorkOrder/AssignWorkOrder', {
		orderid: oid, //否	strubg	工单ID
		// isend: ltype, //否	int	
		clbm: $("#clbm").val(), //是	int	部门Id
		clid: $("#clid").val(), //否	int	接收人用户id
		cont: $("#cont").val(), //否	int	处理内容
		token: $.cookie("token")
	}, function(result) {
		result = $.parseJSON(result);
		if(result.state.toLowerCase() == "success") {
			if(isDetail === "true") {
				parent.parent.layer.closeAll();
				parent.parent.$('#orderlist').bootstrapTable('refresh');
				parent.parent.layer.msg("工单转派成功！");
			} else {
				var index = parent.layer.getFrameIndex(window.name); //先得到当前iframe层的索引
				parent.layer.close(index); //再执行关闭
				parent.$('#workorderlist').bootstrapTable('refresh');
				parent.$('.Closed').trigger('click');
				parent.layer.msg("工单转派成功！");
			}
			top.workcount();
		}
	})
}